com.io7m.r2.filters

## Class R2ShaderSSAOParameters.Builder

- java.lang.Object
- - com.io7m.r2.filters.R2ShaderSSAOParameters.Builder

- Enclosing class:
    R2ShaderSSAOParameters

      public static final class R2ShaderSSAOParameters.Builder
      extends Object

  Builds instances of type `R2ShaderSSAOParameters`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

  `Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `R2ShaderSSAOParameters` | `build()` Builds a new `R2ShaderSSAOParameters`.
    `R2ShaderSSAOParameters.Builder` | `from(R2ShaderSSAOParametersType instance)` Fill a builder with attribute values from the provided `R2ShaderSSAOParametersType` instance.
    `R2ShaderSSAOParameters.Builder` | `setExponent(float exponent)` Initializes the value for the `exponent` attribute.
    `R2ShaderSSAOParameters.Builder` | `setGeometryBuffer(R2GeometryBufferUsableType geometryBuffer)` Initializes the value for the `geometryBuffer` attribute.
    `R2ShaderSSAOParameters.Builder` | `setKernel(R2SSAOKernelType kernel)` Initializes the value for the `kernel` attribute.
    `R2ShaderSSAOParameters.Builder` | `setNoiseTexture(R2Texture2DUsableType noiseTexture)` Initializes the value for the `noiseTexture` attribute.
    `R2ShaderSSAOParameters.Builder` | `setSampleRadius(float sampleRadius)` Initializes the value for the `sampleRadius` attribute.
    `R2ShaderSSAOParameters.Builder` | `setViewMatrices(R2MatricesObserverValuesType viewMatrices)` Initializes the value for the `viewMatrices` attribute.
    `R2ShaderSSAOParameters.Builder` | `setViewport(com.io7m.jareas.core.AreaInclusiveUnsignedLType viewport)` Initializes the value for the `viewport` attribute.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### from

          public final R2ShaderSSAOParameters.Builder from(R2ShaderSSAOParametersType instance)

      Fill a builder with attribute values from the provided `R2ShaderSSAOParametersType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
      Parameters:
        `instance` - The instance from which to copy values
      Returns:
        `this` builder for use in a chained invocation

    - #### setExponent

          public final R2ShaderSSAOParameters.Builder setExponent(float exponent)

      Initializes the value for the `exponent` attribute.

      If not set, this attribute will have a default value as returned by the initializer of `exponent`.

      Parameters:
        `exponent` - The value for exponent
      Returns:
        `this` builder for use in a chained invocation

    - #### setSampleRadius

          public final R2ShaderSSAOParameters.Builder setSampleRadius(float sampleRadius)

      Initializes the value for the `sampleRadius` attribute.

      If not set, this attribute will have a default value as returned by the initializer of `sampleRadius`.

      Parameters:
        `sampleRadius` - The value for sampleRadius
      Returns:
        `this` builder for use in a chained invocation

    - #### setKernel

          public final R2ShaderSSAOParameters.Builder setKernel(R2SSAOKernelType kernel)

      Initializes the value for the `kernel` attribute.
      Parameters:
        `kernel` - The value for kernel
      Returns:
        `this` builder for use in a chained invocation

    - #### setNoiseTexture

          public final R2ShaderSSAOParameters.Builder setNoiseTexture(R2Texture2DUsableType noiseTexture)

      Initializes the value for the `noiseTexture` attribute.
      Parameters:
        `noiseTexture` - The value for noiseTexture
      Returns:
        `this` builder for use in a chained invocation

    - #### setViewport

          public final R2ShaderSSAOParameters.Builder setViewport(com.io7m.jareas.core.AreaInclusiveUnsignedLType viewport)

      Initializes the value for the `viewport` attribute.
      Parameters:
        `viewport` - The value for viewport
      Returns:
        `this` builder for use in a chained invocation

    - #### setViewMatrices

          public final R2ShaderSSAOParameters.Builder setViewMatrices(R2MatricesObserverValuesType viewMatrices)

      Initializes the value for the `viewMatrices` attribute.
      Parameters:
        `viewMatrices` - The value for viewMatrices
      Returns:
        `this` builder for use in a chained invocation

    - #### setGeometryBuffer

          public final R2ShaderSSAOParameters.Builder setGeometryBuffer(R2GeometryBufferUsableType geometryBuffer)

      Initializes the value for the `geometryBuffer` attribute.
      Parameters:
        `geometryBuffer` - The value for geometryBuffer
      Returns:
        `this` builder for use in a chained invocation

    - #### build

          public R2ShaderSSAOParameters build()

      Builds a new `R2ShaderSSAOParameters`.
      Returns:
        An immutable instance of R2ShaderSSAOParameters
      Throws:
        `IllegalStateException` - if any required attributes are missing

Copyright © 2016 <code@io7m.com> http://io7m.com